// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Compute.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Describes the properties of a VM size.
    /// </summary>
    public partial class VirtualMachineSize
    {
        /// <summary>
        /// Initializes a new instance of the VirtualMachineSize class.
        /// </summary>
        public VirtualMachineSize() { }

        /// <summary>
        /// Initializes a new instance of the VirtualMachineSize class.
        /// </summary>
        /// <param name="name">the VM size name.</param>
        /// <param name="numberOfCores">the Number of cores supported by a VM
        /// size.</param>
        /// <param name="osDiskSizeInMB">the OS disk size allowed by a VM
        /// size.</param>
        /// <param name="resourceDiskSizeInMB">the Resource disk size allowed
        /// by a VM size.</param>
        /// <param name="memoryInMB">the Memory size supported by a VM
        /// size.</param>
        /// <param name="maxDataDiskCount">the Maximum number of data disks
        /// allowed by a VM size.</param>
        public VirtualMachineSize(string name = default(string), int? numberOfCores = default(int?), int? osDiskSizeInMB = default(int?), int? resourceDiskSizeInMB = default(int?), int? memoryInMB = default(int?), int? maxDataDiskCount = default(int?))
        {
            Name = name;
            NumberOfCores = numberOfCores;
            OsDiskSizeInMB = osDiskSizeInMB;
            ResourceDiskSizeInMB = resourceDiskSizeInMB;
            MemoryInMB = memoryInMB;
            MaxDataDiskCount = maxDataDiskCount;
        }

        /// <summary>
        /// Gets or sets the VM size name.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets the Number of cores supported by a VM size.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "numberOfCores")]
        public int? NumberOfCores { get; set; }

        /// <summary>
        /// Gets or sets the OS disk size allowed by a VM size.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "osDiskSizeInMB")]
        public int? OsDiskSizeInMB { get; set; }

        /// <summary>
        /// Gets or sets the Resource disk size allowed by a VM size.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "resourceDiskSizeInMB")]
        public int? ResourceDiskSizeInMB { get; set; }

        /// <summary>
        /// Gets or sets the Memory size supported by a VM size.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "memoryInMB")]
        public int? MemoryInMB { get; set; }

        /// <summary>
        /// Gets or sets the Maximum number of data disks allowed by a VM size.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "maxDataDiskCount")]
        public int? MaxDataDiskCount { get; set; }

    }
}
