// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Graph.RBAC.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Active Directory group information
    /// </summary>
    public partial class ADGroupInner
    {
        /// <summary>
        /// Initializes a new instance of the ADGroupInner class.
        /// </summary>
        public ADGroupInner() { }

        /// <summary>
        /// Initializes a new instance of the ADGroupInner class.
        /// </summary>
        /// <param name="objectId">object Id</param>
        /// <param name="objectType">object type</param>
        /// <param name="displayName">group display name</param>
        /// <param name="securityEnabled">security enabled field</param>
        /// <param name="mail">mail field</param>
        public ADGroupInner(string objectId = default(string), string objectType = default(string), string displayName = default(string), bool? securityEnabled = default(bool?), string mail = default(string))
        {
            ObjectId = objectId;
            ObjectType = objectType;
            DisplayName = displayName;
            SecurityEnabled = securityEnabled;
            Mail = mail;
        }

        /// <summary>
        /// Gets or sets object Id
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "objectId")]
        public string ObjectId { get; set; }

        /// <summary>
        /// Gets or sets object type
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "objectType")]
        public string ObjectType { get; set; }

        /// <summary>
        /// Gets or sets group display name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets security enabled field
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "securityEnabled")]
        public bool? SecurityEnabled { get; set; }

        /// <summary>
        /// Gets or sets mail field
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "mail")]
        public string Mail { get; set; }

    }
}
