// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Graph.RBAC.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Active Directory user information
    /// </summary>
    public partial class UserInner
    {
        /// <summary>
        /// Initializes a new instance of the UserInner class.
        /// </summary>
        public UserInner() { }

        /// <summary>
        /// Initializes a new instance of the UserInner class.
        /// </summary>
        /// <param name="objectId">object Id</param>
        /// <param name="objectType">object type</param>
        /// <param name="userPrincipalName">user principal name</param>
        /// <param name="displayName">user display name</param>
        /// <param name="signInName">user signIn name</param>
        /// <param name="mail">user mail</param>
        /// <param name="mailNickname">The mail alias for the user</param>
        public UserInner(string objectId = default(string), string objectType = default(string), string userPrincipalName = default(string), string displayName = default(string), string signInName = default(string), string mail = default(string), string mailNickname = default(string))
        {
            ObjectId = objectId;
            ObjectType = objectType;
            UserPrincipalName = userPrincipalName;
            DisplayName = displayName;
            SignInName = signInName;
            Mail = mail;
            MailNickname = mailNickname;
        }

        /// <summary>
        /// Gets or sets object Id
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "objectId")]
        public string ObjectId { get; set; }

        /// <summary>
        /// Gets or sets object type
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "objectType")]
        public string ObjectType { get; set; }

        /// <summary>
        /// Gets or sets user principal name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "userPrincipalName")]
        public string UserPrincipalName { get; set; }

        /// <summary>
        /// Gets or sets user display name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "displayName")]
        public string DisplayName { get; set; }

        /// <summary>
        /// Gets or sets user signIn name
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "signInName")]
        public string SignInName { get; set; }

        /// <summary>
        /// Gets or sets user mail
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "mail")]
        public string Mail { get; set; }

        /// <summary>
        /// Gets or sets the mail alias for the user
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "mailNickname")]
        public string MailNickname { get; set; }

    }
}
