// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.KeyVault.Fluent.Models
{

    /// <summary>
    /// Defines values for KeyPermissions.
    /// </summary>
    public partial class KeyPermissions
    {
        public static readonly KeyPermissions All = new KeyPermissions("all");
        public static readonly KeyPermissions Encrypt = new KeyPermissions("encrypt");
        public static readonly KeyPermissions Decrypt = new KeyPermissions("decrypt");
        public static readonly KeyPermissions Wrapkey = new KeyPermissions("wrapkey");
        public static readonly KeyPermissions Unwrapkey = new KeyPermissions("unwrapkey");
        public static readonly KeyPermissions Sign = new KeyPermissions("sign");
        public static readonly KeyPermissions Verify = new KeyPermissions("verify");
        public static readonly KeyPermissions Get = new KeyPermissions("get");
        public static readonly KeyPermissions List = new KeyPermissions("list");
        public static readonly KeyPermissions Create = new KeyPermissions("create");
        public static readonly KeyPermissions Update = new KeyPermissions("update");
        public static readonly KeyPermissions Import = new KeyPermissions("import");
        public static readonly KeyPermissions Delete = new KeyPermissions("delete");
        public static readonly KeyPermissions Backup = new KeyPermissions("backup");
        public static readonly KeyPermissions Restore = new KeyPermissions("restore");

        private string value;

        /// <summary>
        /// Creates a custom value for KeyPermissions.
        /// </summary>
        /// <param name="permission">the permission value</param>
        public KeyPermissions(string permission)
        {
            this.value = permission;
        }
        
        public override string ToString()
        {
            return this.value;
        }

        public override bool Equals(object obj)
        {

            string value = this.ToString();
            if (!(obj is KeyPermissions))
            {
                return false;
            }

            if (obj == this)
            {
                return true;
            }
            KeyPermissions rhs = (KeyPermissions) obj;
            if (value == null)
            {
                return rhs.value == null;
            }
            return value.Equals(rhs.value);
        }

        public override int GetHashCode()
        {
            return value.GetHashCode();
        }
    }
}
