// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Network.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Path rule of URL path map of application gateway
    /// </summary>
    [Microsoft.Rest.Serialization.JsonTransformation]
    public partial class ApplicationGatewayPathRuleInner : Microsoft.Azure.Management.Resource.Fluent.SubResource
    {
        /// <summary>
        /// Initializes a new instance of the ApplicationGatewayPathRuleInner
        /// class.
        /// </summary>
        public ApplicationGatewayPathRuleInner() { }

        /// <summary>
        /// Initializes a new instance of the ApplicationGatewayPathRuleInner
        /// class.
        /// </summary>
        /// <param name="paths">Path rules of URL path map</param>
        /// <param name="backendAddressPool">Backend address pool resource of
        /// URL path map </param>
        /// <param name="backendHttpSettings">Backend http settings resource
        /// of URL path map </param>
        /// <param name="provisioningState">Path rule of URL path map resource
        /// Updating/Deleting/Failed</param>
        /// <param name="name">Name of the resource that is unique within a
        /// resource group. This name can be used to access the
        /// resource</param>
        /// <param name="etag">A unique read-only string that changes whenever
        /// the resource is updated</param>
        public ApplicationGatewayPathRuleInner(string id = default(string), System.Collections.Generic.IList<string> paths = default(System.Collections.Generic.IList<string>), Microsoft.Azure.Management.Resource.Fluent.SubResource backendAddressPool = default(Microsoft.Azure.Management.Resource.Fluent.SubResource), Microsoft.Azure.Management.Resource.Fluent.SubResource backendHttpSettings = default(Microsoft.Azure.Management.Resource.Fluent.SubResource), string provisioningState = default(string), string name = default(string), string etag = default(string))
            : base(id)
        {
            Paths = paths;
            BackendAddressPool = backendAddressPool;
            BackendHttpSettings = backendHttpSettings;
            ProvisioningState = provisioningState;
            Name = name;
            Etag = etag;
        }

        /// <summary>
        /// Gets or sets path rules of URL path map
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.paths")]
        public System.Collections.Generic.IList<string> Paths { get; set; }

        /// <summary>
        /// Gets or sets backend address pool resource of URL path map
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.backendAddressPool")]
        public Microsoft.Azure.Management.Resource.Fluent.SubResource BackendAddressPool { get; set; }

        /// <summary>
        /// Gets or sets backend http settings resource of URL path map
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.backendHttpSettings")]
        public Microsoft.Azure.Management.Resource.Fluent.SubResource BackendHttpSettings { get; set; }

        /// <summary>
        /// Gets or sets path rule of URL path map resource
        /// Updating/Deleting/Failed
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "properties.provisioningState")]
        public string ProvisioningState { get; set; }

        /// <summary>
        /// Gets or sets name of the resource that is unique within a resource
        /// group. This name can be used to access the resource
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "name")]
        public string Name { get; set; }

        /// <summary>
        /// Gets or sets a unique read-only string that changes whenever the
        /// resource is updated
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "etag")]
        public string Etag { get; set; }

    }
}
