// Copyright (c) Microsoft Corporation. All rights reserved.
// Licensed under the MIT License. See License.txt in the project root for
// license information.
// 
// Code generated by Microsoft (R) AutoRest Code Generator 0.17.0.0
// Changes may cause incorrect behavior and will be lost if the code is
// regenerated.

namespace Microsoft.Azure.Management.Resource.Fluent.Models
{
    using System.Linq;

    /// <summary>
    /// Entity representing the reference to the deployment paramaters.
    /// </summary>
    public partial class ParametersLink
    {
        /// <summary>
        /// Initializes a new instance of the ParametersLink class.
        /// </summary>
        public ParametersLink() { }

        /// <summary>
        /// Initializes a new instance of the ParametersLink class.
        /// </summary>
        /// <param name="uri">URI referencing the template.</param>
        /// <param name="contentVersion">If included it must match the
        /// ContentVersion in the template.</param>
        public ParametersLink(string uri, string contentVersion = default(string))
        {
            Uri = uri;
            ContentVersion = contentVersion;
        }

        /// <summary>
        /// Gets or sets URI referencing the template.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "uri")]
        public string Uri { get; set; }

        /// <summary>
        /// Gets or sets if included it must match the ContentVersion in the
        /// template.
        /// </summary>
        [Newtonsoft.Json.JsonProperty(PropertyName = "contentVersion")]
        public string ContentVersion { get; set; }

        /// <summary>
        /// Validate the object.
        /// </summary>
        /// <exception cref="Microsoft.Rest.ValidationException">
        /// Thrown if validation fails
        /// </exception>
        public virtual void Validate()
        {
            if (Uri == null)
            {
                throw new Microsoft.Rest.ValidationException(Microsoft.Rest.ValidationRules.CannotBeNull, "Uri");
            }
        }
    }
}
